SystemOrganization addCategory: #'MatchingBenchmarkPlatform-Model'!
SystemOrganization addCategory: #'MatchingBenchmarkPlatform-View'!
SystemOrganization addCategory: #'MatchingBenchmarkPlatform-Core'!

WAComponent subclass: #MBPHomeview
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-View'!

!MBPHomeview methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 09:56'!
renderContentOn: html

	html heading
		level: 2;
		with: 'Home view. This is the MBP bla blub'! !

WAComponent subclass: #MBPMainpage
	instanceVariableNames: 'matcherList currentView homeView uploadView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-View'!

!MBPMainpage classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/28/2007 13:22'!
canBeRoot

	^true! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 12/30/2007 10:00'!
addMatcher
		
	| matcher |
	matcher := self call: (MBPMatcher new asComponent addValidatedForm).
	
	matcher ifNotNil: [
		self session database addMatcher: matcher]! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 12/30/2007 10:01'!
addPerson
	| person |
	person := self call: (MBPPerson new asComponent addValidatedForm).
	
	person ifNotNil: [
		self session database addPerson: person]! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 12/30/2007 10:19'!
addPublication

	| publication |
	publication := self call: (MBPPublication new asComponent addValidatedForm).
	
	publication ifNotNil: [
		self session database addPublication: publication]! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 11:07'!
children

	^{self matcherList. self uploadResult}! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 09:50'!
currentView
	^ currentView! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 09:50'!
currentView: anObject
	currentView := anObject! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 09:58'!
homeView
	^ homeView ifNil: [ homeView := MBPHomeview new]! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 09:57'!
homeView: anObject
	homeView := anObject! !

!MBPMainpage methodsFor: 'initialize-release' stamp: 'dt 12/30/2007 09:58'!
initialize

	super initialize.
	self currentView: self homeView.! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 09:58'!
matcherList
	^ matcherList ifNil: [ matcherList := MBPMatcherList new]! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 09:48'!
matcherList: anObject
	matcherList := anObject! !

!MBPMainpage methodsFor: 'rendering' stamp: 'dt 12/30/2007 09:50'!
renderBodyOn: html


	html div
		id: 'content';
		with: [
			html render: self currentView]! !

!MBPMainpage methodsFor: 'rendering' stamp: 'dt 12/30/2007 09:53'!
renderContentOn: html


	self
		renderHeaderOn: html;
		renderNavigationOn: html;
		renderBodyOn: html! !

!MBPMainpage methodsFor: 'rendering' stamp: 'dt 12/28/2007 15:05'!
renderHeaderOn: html 

	html div
		id: 'header';
		with: [
			html heading
				level: 1;
				with: MBPConfiguration applicationName]! !

!MBPMainpage methodsFor: 'rendering' stamp: 'dt 12/30/2007 10:47'!
renderNavigationLinksOn: html

	html anchor
		callback: [ self viewHome];
		with: 'Home'.
		
	html anchor
		callback: [self addPerson];
		with: 'Add Person'.
		
	html anchor
		callback: [self addPublication];
		with: 'Submit Publication'.
		
	html anchor
		callback: [self addMatcher];
		with: 'Add Matcher'.
		
	html anchor
		callback: [ self viewMatchers];
		with: 'View Matchers'.
		
	html anchor
		callback: [ self uploadResult];
		with: 'Upload your matching result'.! !

!MBPMainpage methodsFor: 'rendering' stamp: 'dt 12/28/2007 14:20'!
renderNavigationOn: html
		
	html div
		id: 'navigation';
		with: [
			self renderNavigationLinksOn: html]! !

!MBPMainpage methodsFor: 'rendering' stamp: 'dt 12/30/2007 10:47'!
uploadResult
		
	self currentView: self uploadView! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 10:48'!
uploadView
	^ uploadView ifNil: [ uploadView := MBPUploadView new]! !

!MBPMainpage methodsFor: 'accessing' stamp: 'dt 12/30/2007 10:47'!
uploadView: anObject
	uploadView := anObject! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 12/30/2007 09:57'!
viewHome
		
	self currentView: self homeView! !

!MBPMainpage methodsFor: 'actions' stamp: 'dt 12/30/2007 09:50'!
viewMatchers
		
	self currentView: self matcherList! !

WAComponent subclass: #MBPMatcherList
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-View'!

!MBPMatcherList methodsFor: 'actions' stamp: 'dt 12/30/2007 10:44'!
buildReport

	report := MAReport rows: self session database matchers
									description: MBPMatcher description.
									
								
	report addColumn: (MACommandColumn new
		addCommandOn: self selector: #matcherDetails: text: 'Show Details')! !

!MBPMatcherList methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:11'!
children

	^OrderedCollection with: report! !

!MBPMatcherList methodsFor: 'initialize-release' stamp: 'dt 12/30/2007 09:51'!
initialize

	super initialize.
	self buildReport ! !

!MBPMatcherList methodsFor: 'actions' stamp: 'dt 12/30/2007 10:46'!
matcherDetails: aMBPMatcher

	self inform: 'Ist noch nichts... Hier kann dann coole Auswertung und so hin'! !

!MBPMatcherList methodsFor: 'rendering' stamp: 'dt 12/30/2007 09:47'!
renderContentOn: html

	html render: self report ! !

!MBPMatcherList methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:12'!
report
	^ report! !

!MBPMatcherList methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:11'!
report: anObject
	report := anObject! !

WAComponent subclass: #MBPUploadView
	instanceVariableNames: 'licenseAccepted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-View'!

!MBPUploadView methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:51'!
initialize

	super initialize.
	licenseAccepted := false.! !

!MBPUploadView methodsFor: 'accessing' stamp: 'dt 12/30/2007 10:52'!
licenseAccepted
	^ licenseAccepted! !

!MBPUploadView methodsFor: 'accessing' stamp: 'dt 12/30/2007 10:52'!
licenseAccepted: anObject
	licenseAccepted := anObject! !

!MBPUploadView methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:53'!
renderContentOn: html

	self licenseAccepted
		ifFalse: [ self renderLicenseAgreementOn: html]
		ifTrue: [ self renderUploadFormOn: html]! !

!MBPUploadView methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 11:06'!
renderLicenseAcceptFormOn: html

	html form
		with: [
			
			html checkbox
				callback: [:value | self licenseAccepted: value];
				with: 'Accept terms'.
			html submitButton
				value: 'Submit'
			]! !

!MBPUploadView methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:54'!
renderLicenseAgreementOn: html
		
	self renderLicenseTextOn: html.
	self renderLicenseAcceptFormOn: html.! !

!MBPUploadView methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 11:02'!
renderLicenseTextOn: html
	
	html preformatted
		id: 'license';
		with:  (FileDirectory default readOnlyFileNamed: MBPConfiguration licenseFilename) contents ! !

WASession subclass: #MBPSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Core'!

!MBPSession methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:10'!
database

	^MBPDatabase default! !

!MBPSession methodsFor: 'initializing' stamp: 'dt 12/28/2007 15:06'!
initialize

	super initialize ! !

Object subclass: #MBPConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Core'!

!MBPConfiguration classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/28/2007 15:05'!
applicationName
	^ 'Matcher-Benchmark-Platform'! !

!MBPConfiguration classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 11:02'!
licenseFilename

	^'license.txt'! !

Object subclass: #MBPDatabase
	instanceVariableNames: 'persons publications matchers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Core'!

MBPDatabase class
	instanceVariableNames: 'default'!

MBPDatabase class
	instanceVariableNames: 'default'!

!MBPDatabase classSide methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:02'!
default

	^default ifNil: [default := self new]! !

!MBPDatabase classSide methodsFor: 'actions' stamp: 'dt 12/28/2007 15:02'!
resetDatabase

	default := nil! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:08'!
addMatcher: aMBPMatcher

	self matchers add: aMBPMatcher ! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/30/2007 10:02'!
addPerson: aMBPPerson

	self persons add: aMBPPerson! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/30/2007 10:19'!
addPublication: aMBPPublication

	self publications add: aMBPPublication ! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:09'!
initialize

	persons := OrderedCollection new.
	publications := OrderedCollection new.
	matchers := OrderedCollection new.! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:08'!
matchers
	^ matchers! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:08'!
matchers: anObject
	matchers := anObject! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:01'!
persons
	^ persons! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:01'!
persons: anObject
	persons := anObject! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:01'!
publications
	^ publications! !

!MBPDatabase methodsFor: 'accessing' stamp: 'dt 12/28/2007 15:01'!
publications: anObject
	publications := anObject! !

Object subclass: #MBPMatcher
	instanceVariableNames: 'matcherName vendor matcherDescription matcherUri publications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Model'!

!MBPMatcher classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/28/2007 14:28'!
descriptionMatcherDescription

	^MAMemoDescription new
		selectorAccessor: #matcherDescription;
		label: 'Short description';
		priority: 20;
		beRequired;
		yourself! !

!MBPMatcher classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/28/2007 14:34'!
descriptionMatcherName

	^MAStringDescription new
		selectorAccessor: #matcherName;
		label: 'Matcher Name';
		priority: 10;
		beRequired;
		yourself! !

!MBPMatcher classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/28/2007 14:30'!
descriptionMatcherUri

	^MAStringDescription new
		selectorAccessor: #matcherUri;
		label: 'URI';
		priority: 40;
		yourself! !

!MBPMatcher classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/28/2007 14:28'!
descriptionVendor

	^MAStringDescription new
		selectorAccessor: #vendor;
		label: 'Vendor';
		priority: 30;
		yourself! !

!MBPMatcher methodsFor: 'initialize-release' stamp: 'dt 12/28/2007 13:21'!
initialize

	publications := OrderedCollection new! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:17'!
matcherDescription
	^ matcherDescription! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:17'!
matcherDescription: anObject
	matcherDescription := anObject! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:16'!
matcherName
	^ matcherName! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:16'!
matcherName: anObject
	matcherName := anObject! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:17'!
matcherUri
	^ matcherUri! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:17'!
matcherUri: anObject
	matcherUri := anObject! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:21'!
publications
	^ publications! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:21'!
publications: anObject
	publications := anObject! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:17'!
vendor
	^ vendor! !

!MBPMatcher methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:17'!
vendor: anObject
	vendor := anObject! !

Object subclass: #MBPPerson
	instanceVariableNames: 'firstname lastname email homepage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Model'!

!MBPPerson classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:04'!
descriptionEmail

	^MAStringDescription new
		selectorAccessor: #email;
		label: 'E-mail address';
		priority: 30;
		yourself! !

!MBPPerson classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:05'!
descriptionFirstname

	^MAStringDescription new
		selectorAccessor: #firstname;
		label: 'Firstname';
		priority: 10;
		beRequired;
		yourself! !

!MBPPerson classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:04'!
descriptionHomepage

	^MAStringDescription new
		selectorAccessor: #homepage;
		label: 'Homepage';
		priority: 40;
		yourself! !

!MBPPerson classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:05'!
descriptionLastname

	^MAStringDescription new
		selectorAccessor: #lastname;
		label: 'Lastname';
		priority: 20;
		beRequired;
		yourself! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
email
	^ email! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
email: anObject
	email := anObject! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
firstname
	^ firstname! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
firstname: anObject
	firstname := anObject! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
homepage
	^ homepage! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
homepage: anObject
	homepage := anObject! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
lastname
	^ lastname! !

!MBPPerson methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:18'!
lastname: anObject
	lastname := anObject! !

Object subclass: #MBPPublication
	instanceVariableNames: 'title abstract authors year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MatchingBenchmarkPlatform-Model'!

!MBPPublication classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:12'!
descriptionAbstract

	^MAMemoDescription new
		selectorAccessor: #abstract;
		label: 'Abstract';
		priority: 20;
		beRequired;
		yourself! !

!MBPPublication classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:40'!
descriptionAuthors

	^MAMultipleOptionDescription new
		selectorAccessor: #authors;
		label: 'Authors';
		priority: 30;
		options: [MBPDatabase default persons ] asDynamicObject;
		reference:  ((MBPPerson descriptionContainer)
					add: MBPPerson descriptionFirstname;
					add: MBPPerson descriptionLastname;
					yourself);
		yourself
		! !

!MBPPublication classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:12'!
descriptionTitle

	^MAStringDescription new
		selectorAccessor: #title;
		label: 'Title';
		priority: 10;
		beRequired;
		yourself! !

!MBPPublication classSide methodsFor: 'as yet unclassified' stamp: 'dt 12/30/2007 10:12'!
descriptionYear

	^MADateDescription new
		selectorAccessor: #year;
		label: 'Publication date';
		priority: 40;
		beRequired;
		yourself! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
abstract
	^ abstract! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
abstract: anObject
	abstract := anObject! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
authors
	^ authors! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
authors: anObject
	authors := anObject! !

!MBPPublication methodsFor: 'initialize-release' stamp: 'dt 12/28/2007 13:19'!
initalize
	
	authors := OrderedCollection new! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
title
	^ title! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
title: anObject
	title := anObject! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
year
	^ year! !

!MBPPublication methodsFor: 'accessing' stamp: 'dt 12/28/2007 13:19'!
year: anObject
	year := anObject! !
